#ifndef RENDERTEXTURE_H
#define RENDERTEXTURE_H

// Video & graphics stuff
#include "C:\Projects\glew\include\GL\glew.h"
#ifdef _WIN32
	#include "C:\Projects\glew\include\GL\wglew.h"
#else
	#include <GL/glxew.h>
#endif
#include "openglheaders.h"
#include "video.h"

// WX
#include "wx/wxprec.h"
#ifdef __BORLANDC__
    #pragma hdrstop
#endif
#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif

class RenderTexture {
	HPBUFFERARB hPBuffer;
    HDC         hDC;
    HGLRC       hRC;

	HWND		canvas_hWnd;
	HDC         canvas_hDC;
    HGLRC       canvas_hRC;

	GLuint		frameBuffer;
	GLuint		depthRenderBuffer;

	GLuint		texID;
	GLenum		texFormat;

	bool		FBO;

public:

	int         nWidth;
    int         nHeight;

	RenderTexture() { 
		hPBuffer = NULL;
		hDC = NULL;
		hRC = NULL;
	}
	~RenderTexture(){
		if (hRC != NULL)
			Shutdown();
	}

	void Init(HWND g_hWnd, int width, int height, bool fbomode);
	void Shutdown();

	void BeginRender();
	void EndRender();

	void BindTexture();
	void UnBindTexture();

	void InitGL();

};

#endif //RENDERTEXTURE_H

