
#ifndef IMAGECONTROL_H
#define IMAGECONTROL_H

#include "wx/wxprec.h"
#ifdef __BORLANDC__
    #pragma hdrstop
#endif
#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif

#include "video.h"
#include "modelcanvas.h"
#include "wxaui_manager.h"

class ImageControl: public wxWindow
{
	DECLARE_CLASS(ImageControl)
	DECLARE_EVENT_TABLE()
	
	wxCheckBox *lockAspect;
	wxButton *save, *cancel;
	wxTextCtrl *filename, *canvasWidth, *canvasHeight;

	wxStaticText *maxsize;
	
	ModelCanvas *cc;

	float aspect;
	bool locked;
	bool skipEvent;

	int x, y;
	int maxSize;

	wxPaneInfo *pane;
	wxFrameManager *manager;
	
public:
	ImageControl(wxWindow *parent, wxWindowID id, ModelCanvas *cc);
	~ImageControl();

	void OnShow(wxFrameManager *m);

	void OnCheck(wxCommandEvent &event);
	void OnButton(wxCommandEvent &event);
	void OnText(wxCommandEvent &event);
};


#endif
