#ifndef OPENGLHEADERS_H
#define OPENGLHEADERS_H

#include "C:\Projects\glew\include\GL\glew.h"

#ifdef _WIN32
	#include "C:\Projects\glew\include\GL\wglew.h"
#else
	#include <GL/glxew.h>
#endif

#ifdef _WIN32
#include <windows.h>
#endif

// opengl
#ifdef __WXMAC__ //Mac
#	ifdef __DARWIN__
#		include <OpenGL/gl.h>
#		include <OpenGL/glaux.h>
#		include <OpenGL/glu.h>
#	else
#		include <gl.h>
#		include <glu.h>
#		include <glaux.h>
#	endif
#else
#	include <GL/gl.h>
#	include <GL/glu.h>
// #	include <GL/glut.h>
#	ifdef _WIN32
#		include <GL/glaux.h>
#		include "wglext.h"		//WGL extensions
#		include "glext.h"		//GL extensions
#	else
#		include <stdarg.h>
#		include <GL/glext.h>
#		include <GL/glx.h>
#	endif
#endif

#include "wx/glcanvas.h"

#ifdef _WIN32
	// non-vbo
	//extern PFNGLDRAWRANGEELEMENTSPROC glDrawRangeElements;

#else // Linux
	// VBO Extension Definitions, From glext.h
	#define GL_ARRAY_BUFFER_ARB 0x8892
	#define GL_STATIC_DRAW_ARB 0x88E4
	#define GL_STREAM_DRAW_ARB 0x88E0
	#define GL_WRITE_ONLY 0x88B9

	#define GL_COMPRESSED_RGB_S3TC_DXT1_EXT 0x83F0
	#define GL_COMPRESSED_RGB_S3TC_DXT3_EXT 0x83F2
	
	// Texture Compression
	typedef void (APIENTRY * PFNGLCOMPRESSEDTEXIMAGE2DARBPROC) (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const GLvoid *data);

	// Multi Textures
	typedef void (APIENTRY * PFNGLACTIVETEXTUREARBPROC) (GLenum texture);
	typedef void (APIENTRY * PFNGLCLIENTACTIVETEXTUREARBPROC) (GLenum texture);
	typedef void (APIENTRY * PFNGLMULTITEXCOORD2FARBPROC) (GLenum target, GLfloat s, GLfloat t);

	// Draw Range Elements
	typedef void (APIENTRYP PFNGLDRAWRANGEELEMENTSPROC) (GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const GLvoid *indices);

	// VBO extensions
	typedef void (APIENTRY * PFNGLBINDBUFFERARBPROC) (GLenum target, GLuint buffer);
	typedef void (APIENTRY * PFNGLDELETEBUFFERSARBPROC) (GLsizei n, const GLuint *buffers);
	typedef void (APIENTRY * PFNGLGENBUFFERSARBPROC) (GLsizei n, GLuint *buffers);
	typedef void (APIENTRY * PFNGLBUFFERDATAARBPROC) (GLenum target, int size, const GLvoid *data, GLenum usage);
	//Map/unmap buffer
	typedef GLvoid* (APIENTRY * PFNGLMAPBUFFERARBPROC) (GLenum target, GLenum access);
	typedef GLboolean (APIENTRY * PFNGLUNMAPBUFFERARBPROC) (GLenum target);

	/*
	// multi textures
	extern PFNGLMULTITEXCOORD2FARBPROC glMultiTexCoord2fARB;
	extern PFNGLACTIVETEXTUREARBPROC glActiveTextureARB;
	extern PFNGLCLIENTACTIVETEXTUREARBPROC glClientActiveTextureARB;

	// compressed textures
	extern PFNGLCOMPRESSEDTEXIMAGE2DARBPROC glCompressedTexImage2DARB;

	// VBO
	extern PFNGLGENBUFFERSARBPROC glGenBuffersARB;
	extern PFNGLBINDBUFFERARBPROC glBindBufferARB;
	extern PFNGLBUFFERDATAARBPROC glBufferDataARB;
	extern PFNGLDELETEBUFFERSARBPROC glDeleteBuffersARB;

	extern PFNGLMAPBUFFERARBPROC glMapBufferARB;
	extern PFNGLUNMAPBUFFERARBPROC glUnmapBufferARB;

	// GL_ARB_point_parameters
	extern PFNGLPOINTPARAMETERFARBPROC  glPointParameterfARB;
	extern PFNGLPOINTPARAMETERFVARBPROC glPointParameterfvARB;

	// GL_ARB_fragment_program
	extern PFNGLPROGRAMSTRINGARBPROC glProgramStringARB;
	extern PFNGLBINDPROGRAMARBPROC glBindProgramARB;
	extern PFNGLDELETEPROGRAMSARBPROC glDeleteProgramsARB;
	extern PFNGLGENPROGRAMSARBPROC glGenProgramsARB;
	*/
#endif

#define GL_BUFFER_OFFSET(i) ((char *)(0) + (i))

typedef GLuint TextureID;

#endif

