
#include "shader.h"

Shader::Shader(wxString fn) 
{
	psHeader = NULL;
	vsHeader = NULL;
	int count = 0;
	int offset = 0;

	MPQFile f(fn);
	if (!f.isEof() && f.getSize() > sizeof(ShaderHeader)) {
		//memcpy(&header, f.getBuffer(), sizeof(ShaderHeader));
		f.read(&header.id, 4);
		f.read(&header.version, 4);
		f.read(&header.count, 4);

		if (header.id[1] == 'P') {
			f.seek(12);
			psHeader = new PShaderHeader;
			//f.read(&psHeader->id1, 1);
			//f.read(&psHeader->id2, 1);
			f.read(&psHeader->block, 48);
			//memcpy(psHeader, f.getBuffer() + 12, sizeof(PShaderHeader));
			//psHeader = (PShaderHeader*)(f.getBuffer() + offset);
			count = 12;
		} else if (header.id[1] == 'V') {
			//memcpy(vsHeader, f.getBuffer() + 12, sizeof(VShaderHeader));
			vsHeader = (VShaderHeader*)(f.getBuffer() + offset);
			count = 6;
		}
		
		block.clear();
		PermutationBlock p;
		// We're only interested in the OpenGL ones!
		for (int i=0; i<count; i++) {
			if (psHeader->block[i] > 0) {
				f.seek(psHeader->block[i]);

				if (!f.isEof()) {
					f.read(&p.paramCount, 4);
					if (p.paramCount > 0) {
						p.param = (char*) malloc(144);
						f.read(p.param, 144);
					}

					f.read(&p.texCount, 4);
					if (p.texCount > 0) {
						
						p.tex = (char*) malloc(144);

						for (unsigned int k=0; k<p.texCount; k++) {
							f.read(p.tex, 144);
						}
					}

					f.read(&p.flag, 4);
					f.read(&p.blockcount, 4);
					if (p.blockcount > 0) {
						p.block = (char*) malloc(p.blockcount);
						f.read(p.block, p.blockcount);
					}

					block.push_back(p);
				}
			}
		}
	}

	f.close();
}

Shader::~Shader()
{
	
}

unsigned int Shader::Load()
{
	GLuint retcode = 0;
	char *program_string = "!!ARBfp1.0.PARAM c[2] = { { 1, 0.29899999, 0.58700001, 0.14399999 },...{ 4 } };.TEMP R0;.TEMP R1;.TEX R0.xyz, fragment.texcoord[1], texture[1], RECT;.TEX R1.xyz, fragment.texcoord[0], texture[0], RECT;.MUL R0.xyz, R0, R0;.MAD R0.xyz, R0, fragment.color.primary.w, R1;.DP3_SAT R0.x, R0, c[0].yzww;.ADD R0.y, -R0.x, c[0].x;.MUL R0.y, R0.x, R0;.MUL_SAT R0.y, R0, c[1].x;.MAD result.color.xyz, fragment.color.primary, R0.y, R0.x;.MOV result.color.w, c[0].x;.END";

	glEnable(GL_FRAGMENT_PROGRAM_ARB);
	glGenProgramsARB(1, &retcode);
	glBindProgramARB(GL_FRAGMENT_PROGRAM_ARB, retcode);
	
	/*
	for (std::list<PermutationBlock>::iterator it = block.begin(); it != block.end(); ++it) {
		if (it->block[0] == '!') {
			program_string = it->block;
			glProgramStringARB(GL_FRAGMENT_PROGRAM_ARB, GL_PROGRAM_FORMAT_ASCII_ARB, strlen(program_string), program_string);
			break;
		}
	}*/

	glProgramStringARB(GL_FRAGMENT_PROGRAM_ARB, GL_PROGRAM_FORMAT_ASCII_ARB, (GLsizei)strlen(program_string), program_string);
	
	return retcode;
}

