#ifndef SHADER_H
#define SHADER_H

#include "wx/wx.h"
//#include "wx/glcanvas.h"

#include "mpq_libmpq.h"

#include "video.h"
#include "glext.h"
//#include "util.h"

//#include "animcontrol.h"

/*
#ifdef _WIN32
	#include <GL/gl.h>
	#include <GL/glu.h>
	//#include <GL/glaux.h>
	#include "glext.h"		//GL extensions
	#include "wglext.h"		//WGL extensions
#endif
*/

struct ShaderHeader {
	char id[4];					// Chunk identifier - in reverse character order: "SVXG" in case of a vertex shader, "SPXG" in case of a fragment shader
	unsigned char version[4];	// Always 0x10003 - version 1.3 of format 
	unsigned int count;			// Permutation count
};

struct VShaderHeader {
	unsigned int block[6];
};

struct PShaderHeader {
	unsigned int block[12];
};

struct PermutationBlock {
	unsigned int paramCount; //Generally 0, if 1 there are 0x90 bytes of extra header after this byte (some parameter name?)
	char *param;
	unsigned int texCount; //Generally 0, if 1 there are 0x90 bytes of extra header after this byte (some texture name?) 
	char *tex;

	unsigned int flag;
	unsigned int blockcount;
	char *block;
};

class Shader {
public:
	Shader(wxString fn);
	~Shader();

	unsigned int Load();

	ShaderHeader header;
	VShaderHeader *vsHeader;
	PShaderHeader *psHeader;
	std::list<PermutationBlock> block;
};

#endif
