#include "util.h"
#include "CxImage/ximage.h"

wxString gamePath;
wxString testPath;
wxString cfgPath;
wxString bgImagePath;

bool useTestPatch = false;
bool usePatch = true;
bool useLocalFiles = false;
bool useELP = false;
bool useFLP = false;
bool useGLP = false;

long langID = -1;
int ssCounter = 100;
int imgFormat = 0;

float frand()
{
    return rand()/(float)RAND_MAX;
}

float randfloat(float lower, float upper)
{
	return lower + (upper-lower)*(rand()/(float)RAND_MAX);
}

int randint(int lower, int upper)
{
    return lower + (int)((upper+1-lower)*frand());
}

void fixname(std::string &name)
{
	for (size_t i=0; i<name.length(); i++) {
		if (i>0 && name[i]>='A' && name[i]<='Z' && isalpha(name[i-1])) {
			name[i] |= 0x20;
		} else if ((i==0 || !isalpha(name[i-1])) && name[i]>='a' && name[i]<='z') {
			name[i] &= ~0x20;
		}
	}
}
void fixnamen(char *name, size_t len)
{
	for (size_t i=0; i<len; i++) {
		if (i>0 && name[i]>='A' && name[i]<='Z' && isalpha(name[i-1])) {
			name[i] |= 0x20;
		} else if ((i==0 || !isalpha(name[i-1])) && name[i]>='a' && name[i]<='z') {
			name[i] &= ~0x20;
		}
	}
}

void getGamePath()
{
	useTestPatch = false;
	usePatch = true;

#ifdef _WIN32
	HKEY key;
	DWORD t, s;
	LONG l;
	unsigned char path[1024];
	memset(path, 0, 1024);
	s = 1024;
	
	l = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Blizzard Entertainment\\World of Warcraft", 0, KEY_QUERY_VALUE, &key);
	l = RegQueryValueEx(key, "InstallPath", 0, &t,(LPBYTE)path, &s);
	RegCloseKey(key);

	// See if patch.mpq exists in the WoWTest data folder
	testPath = gamePath = (char*)path;
	testPath.append("WoWTest\\Data\\");
	
	// Following chunk of code is used to determin if the test patch exists, and if so it flagged the program to use the test patch/
	// I've decided its in end-users best interest to leave this off by default.
	//FILE *stream;
	//if((stream = fopen(testpath.fn_str(), "r")) != NULL )
	//{
	//	// wow test data exists -- need to add in some sort of checking to see if its newer data
	//	useTestPatch = true;
	//	fclose(stream);
	//}
	
	//testpath = gamepath;
	//testpath.append("WoWTest\\Data\\");
	gamePath.append("Data\\");

#else // linux - not sure what it should be set to for Mac osx
	gamePath = "/data/";
	testPath = "/data/";
	
#endif
}


