#ifndef VIDEO_H
#define VIDEO_H

#include "openglheaders.h"
#include "RenderTexture.h"

#include "util.h"
#include "vec3d.h"
#include "manager.h"
#include "mpq.h"
#include "ddslib.h"

using namespace std;

#ifndef PI
	#define PI 3.14159265358f
#endif


class Texture : public ManagedItem {
public:
	int w,h;
	GLuint id;
	bool compressed;

	Texture(std::string name):ManagedItem(name), w(0), h(0), id(0), compressed(false) {}
	void getPixels(unsigned char *buf);

};

class TextureManager : public Manager<GLuint> {
	
public:
	virtual GLuint add(std::string name);
	void doDelete(GLuint id);

	void LoadBLP(GLuint id, Texture *tex);
};

void getTextureData(GLuint tex, unsigned char *buf);

extern bool supportCompression;
extern bool supportMultiTex;
extern bool supportVBO;
extern bool supportDrawRangeElements;
extern bool supportPointSprites;
extern bool supportShaders;
extern bool supportAntiAlias;
extern bool supportPBuffer;
extern bool supportFBO;
extern bool supportNPOT;
extern bool supportOGL20;
extern bool disableHWAcc;
extern bool useAntiAlias;
extern int arbMultisampleFormat;
extern bool InitMultisample(HDC hDC);

extern GLuint iTextureProgram;
extern GLuint iPassThroughProgram;

extern TextureManager texturemanager;
extern int gXres, gYres;
void InitExtensions();
void decompressDXTC(GLint format, int w, int h, size_t size, unsigned char *src, unsigned char *dest);

//RenderTexture* CreateRenderTexture(const char *initstr, int texWidth, int texHeight);
//void DestroyRenderTexture(RenderTexture *rt2);

#endif

