#ifndef VIEWCONTROL_H
#define VIEWCONTROL_H

#include "wx/wxprec.h"
#ifdef __BORLANDC__
    #pragma hdrstop
#endif
#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif

// wxwidgets
#include "wx/radiobut.h"

// custom headers
#include "vec3d.h"
#include "quaternion.h"

#include "enums.h"

// custom objects
class ModelViewer;
class ModelCanvas;


class ViewControl: public wxWindow
{
	DECLARE_CLASS(ViewControl)
    DECLARE_EVENT_TABLE()

	Vec3D vPos, vRot;
	
	wxTextCtrl *txtFov;
	wxTextCtrl *txtPos[3];
	wxTextCtrl *txtRot[3];

public:

	ViewControl(wxWindow* parent, wxWindowID id);
	~ViewControl();
	
	void OnButton(wxCommandEvent &event);
	void OnText(wxCommandEvent &event);
	void Init();
	void Refresh();
	void Update();
	
	ModelViewer *modelViewer;
	ModelCanvas *canvas;
};


#endif

